import {Component, OnInit, Input } from 'angular2/core';
import { registerElement } from 'nativescript-angular/element-registry';

registerElement('ParallaxView', () => require('nativescript-parallax').ParallaxView);

@Component({
	selector: 'parallax-view',
	template: `
				<ParallaxView controlsToFade="headerLabel,headerLabel2">
					<StackLayout id="height">
						<ng-content select="[head]"></ng-content>
					</StackLayout>
					<StackLayout>
						<ng-content select="[body]"></ng-content>
					</StackLayout>
				</ParallaxView>
			`,
	styles: [`
	#height{
		height:200px
	}
	`]
})
export class ParallaxView implements OnInit {

	@Input('head-height') public topViewHeight: number;
	@Input('controls-to-fade') public controlsToFade: string[];

	constructor() {

	}
	ngOnInit() {

	}
}