"use strict";
var di_1 = require('../di');
var lang_1 = require('angular2/src/facade/lang');
var element_1 = require('./element');
var directive_resolver_1 = require('./directive_resolver');
var pipe_provider_1 = require('../pipes/pipe_provider');
var pipe_resolver_1 = require('./pipe_resolver');
var ResolvedMetadataCache = (function () {
    function ResolvedMetadataCache(_directiveResolver, _pipeResolver) {
        this._directiveResolver = _directiveResolver;
        this._pipeResolver = _pipeResolver;
        this._directiveCache = new Map();
        this._pipeCache = new Map();
    }
    ResolvedMetadataCache.prototype.getResolvedDirectiveMetadata = function (type) {
        var result = this._directiveCache.get(type);
        if (lang_1.isBlank(result)) {
            result = element_1.DirectiveProvider.createFromType(type, this._directiveResolver.resolve(type));
            this._directiveCache.set(type, result);
        }
        return result;
    };
    ResolvedMetadataCache.prototype.getResolvedPipeMetadata = function (type) {
        var result = this._pipeCache.get(type);
        if (lang_1.isBlank(result)) {
            result = pipe_provider_1.PipeProvider.createFromType(type, this._pipeResolver.resolve(type));
            this._pipeCache.set(type, result);
        }
        return result;
    };
    ResolvedMetadataCache = __decorate([
        di_1.Injectable()
    ], ResolvedMetadataCache);
    return ResolvedMetadataCache;
}());
exports.ResolvedMetadataCache = ResolvedMetadataCache;
exports.CODEGEN_RESOLVED_METADATA_CACHE = new ResolvedMetadataCache(directive_resolver_1.CODEGEN_DIRECTIVE_RESOLVER, pipe_resolver_1.CODEGEN_PIPE_RESOLVER);
//# sourceMappingURL=resolved_metadata_cache.js.map