/**
 * Creates keys for `private` properties on exposed objects to minimize interactions with other codebases.
 */
"use strict";
function create(name) {
    // `Symbol` implementation is broken in Chrome 39.0.2171, do not use them even if they are available
    return '_zone$' + name;
}
exports.create = create;
exports.common = {
    addEventListener: create('addEventListener'),
    removeEventListener: create('removeEventListener')
};
//# sourceMappingURL=keys.js.map